unit UModele;

interface

const NB_COLONNES = 7;
      NB_RANGEES = 6;

type TColonne = array[0..NB_RANGEES-1] of integer;
     TGrille  = array[0..NB_COLONNES-1] of TColonne;

procedure initialise;
procedure setGrilleElem(const x,y:byte; const j:integer);
function getGrilleElem(const x,y:byte) : integer;
function gagnant(const joueur:integer) : boolean; 

implementation

uses UControlleur;

var G: TGrille;

procedure initialise;
var x,y: byte;
begin
   for x:= 0 to NB_COLONNES-1 do
      for y:= 0 to NB_RANGEES-1 do
         G[x][y] := CASEVIDE;
end;

procedure setGrilleElem(const x,y:byte; const j:integer);
begin
   G[x][y] := j;
end;

function getGrilleElem(const x,y:byte) : integer;
begin
   result := G[x][y];
end;

function gagnant(const joueur:integer) : boolean;

   function verticale : boolean;
   var x,y,i: byte;
       jetons: integer;
   begin
      for x:= 0 to NB_COLONNES-1 do
         for y:= 0 to NB_RANGEES-4 do
            if G[x][y] = joueur then
               begin
                  jetons := joueur;
                  for i:= y+1 to y+3 do
                     jetons := jetons + G[x][i];
                  if abs(jetons) = 4 then
                     begin
                        result := true;
                        exit;
                     end;
               end;
   end;

   function horizontale : boolean;
   var x,y,i: byte;
       jetons: integer;
   begin
      for y:= 0 to NB_RANGEES-1 do
         for x:= 0 to NB_COLONNES-4 do
            if G[x][y] = joueur then
               begin
                  jetons := joueur;
                  for i:= x+1 to x+3 do
                     jetons := jetons + G[i][y];
                  if abs(jetons) = 4 then
                     begin
                        result := true;
                        exit;
                     end;
               end;
   end;

   function diagonaleDroite : boolean; // pour les diagonales qui descendent vers la droite
   var x,y,i,j: byte;
       jetons: integer;
   begin
      for y:= 0 to NB_RANGEES-4 do
         for x:= 0 to NB_COLONNES-4 do
            if G[x][y] = joueur then
               begin
                  jetons := joueur;
                  j := y+1;
                  for i:= x+1 to x+3 do
                     begin
                        jetons := jetons + G[i][j];
                        inc(j);
                     end;
                  if abs(jetons) = 4 then
                     begin
                        result := true;
                        exit;
                     end;
               end;
   end;

   function diagonaleGauche : boolean; // pour les diagonales qui descendent vers la gauche
   var x,y,i,j: byte;
       jetons: integer;
   begin
      for y:= 0 to NB_RANGEES-4 do
         for x:=NB_COLONNES-4 to NB_COLONNES-1 do
            if G[x][y] = joueur then
               begin
                  jetons := joueur;
                  i := x-1;
                  for j:= y+1 to y+3 do
                     begin
                        jetons := jetons + G[i][j];
                        dec(i);
                     end;
                  if abs(jetons) = 4 then
                     begin
                        result := true;
                        exit;
                     end;
               end;
   end;

begin
   result := verticale or horizontale or diagonaleDroite or diagonaleGauche;
end; // fin fonction partieFinie

end.
